<template>
    <div class="multiselect-checkbox">
        <div @click="toggleDropdown" class="dropdown-toggle">{{ selectedItemsString }}</div>
        <div v-if="isOpen" class="dropdown-menu">
            <input type="text" v-model="searchQuery" placeholder="Search" class="search-input" />
            <div>
                <input type="checkbox" v-model="selectAll" @change="selectAllChanged" />
                <label>Select All</label>
            </div>
            <div v-for="(group, index) in filteredMenuItems" :key="index">
                <div class="group-label">{{ group.groupLabel }}</div>
                <div v-for="item in group.items">
                    <input type="checkbox" :id="item.value" :value="item.value" :disabled="shouldDisable(item)"
                        v-model="selectedValues" @change="updateSelectedValues($event)" />
                    <label :for="item.value">{{ item.label }}</label>
                </div>
            </div>
        </div>
    </div>
</template>


<script setup lang="ts">
import { ref, computed } from "vue";
import { useDataStore, type MenuItem } from "@/stores/data";

const dataStore = useDataStore();

const lookup = dataStore.createLookup();


const props = defineProps({
    menuData: {
        type: Array<MenuItem>,
        default: () => [
            {
                groupLabel: 'Continents',
                items: [
                    { value: 'africa', label: 'Africa' },
                ]
            },
            {
                groupLabel: 'Subcontinents',
                items: [
                    { value: 'westernAfrica', label: 'Western Africa' },
                ]
            },
            {
                groupLabel: 'Countries',
                items: [
                    { value: 'nigeria', label: 'Nigeria' },
                ]
            },
        ]
    },
    modelValue: {
        type: Array,
        default: () => [],
    },
    maxSelections: {
        type: Number,
        default: 9,
        required: true,

    },
    minSelections: {
        type: Number,
        default: 0,
        required: false,
    },
    buttonText: {
        type: String,
        default: "Geographies selected",
        required: false,
    },

    loookup: {
        type: Function,
        default: () => { },
        required: false,
    }
});

const emit = defineEmits(["update:modelValue"]);


const labels = props.menuData.reduce((acc: Array<string>, group) => {
    group.items.forEach(option => {
        acc.push(option.label);
    });
    return acc;
}, []);


const totalElements = computed(() => {
    return props.menuData.reduce((acc, group) => {
        return acc + group.items.length;
    }, 0);
});

// check if modelValue is empty by removing all empty strings
const isEmptyModelValue = props.modelValue.filter((item: any) => item !== '').length === 0;

const selectedValues = ref(!isEmptyModelValue ? [...props.modelValue] : [...labels]);
const totalSelectedValues = computed(() => { return selectedValues.value.length });
const isAllSelected = computed(() => { return totalSelectedValues.value === totalElements.value });

const selectAll = ref(isAllSelected.value);

const isOpen = ref(false);
const searchQuery = ref('');


const updateSelectedValues = (event: Event) => {

    if (!event.target) {
        return;
    }
    const target = event.target as HTMLInputElement;



    if (totalSelectedValues.value > 0) {
        if (!target.checked) {
            removeFromSelectedItems(target.value);
        }
        else if (target.checked) {
            addToSelectedItems(target.value);
        }
        emit("update:modelValue", selectedValues.value);

    }
    else if (totalSelectedValues.value == 0) {

        emit("update:modelValue", []);
    }
    selectAll.value = isAllSelected.value;
};

const shouldDisable = (item: Record<string, string>) => {
    return (
        totalSelectedValues.value >= props.maxSelections &&
        !selectedValues.value.includes(item.value)
    );
};

const toggleDropdown = () => {
    isOpen.value = !isOpen.value;
};

const selectedItemsString = computed(() => {
    const text = props.buttonText + " - " + "(" + totalSelectedValues.value + " of " + props.maxSelections + ")";
    return text;
});

const filteredMenuItems = computed(() => {

    if (searchQuery.value === "") {
        return props.menuData;
    }

    // Search through each group's items
    const filterResults = (props.menuData).map(group => ({
        ...group,
        items: group.items.filter(item =>
            item.label.toLowerCase().includes(searchQuery.value.toLowerCase())
        )
    })).filter(group => group.items.length > 0);  // Remove groups that have no items after filtering

    return filterResults;
});
const getGroupItems = (groupLabel: string) => {
    const group = props.menuData.filter(group => group.groupLabel == groupLabel);

    if (group.length == 0) {
        return [];
    }

    return group[0].items;
}

const isPartOfGroup = (item: string, level: string) => {
    const groupItems = getGroupItems(level).map(item => item.value);
    return groupItems.includes(item);
};

const getGroupLevel = (item: string) => {
    if (isPartOfGroup(item, 'Countries')) {
        return 'Countries';
    }
    else if (isPartOfGroup(item, 'Subcontinents')) {
        return 'Subcontinents';
    }
    else if (isPartOfGroup(item, 'Continents')) {
        return 'Continents';
    }
    else {
        return '';
    }
};



const removeSubcontinentsAndCountries = (continent: string) => {
    const subcontinentsToRemove = [];
    const subcontinents = lookup.findAllSubcontinentsInContinent(continent);
    for (const subcontinent of subcontinents) {
        const countries = lookup.findAllCountriesInSubcontinent(subcontinent);
        for (const country of countries) {
            removeValueFromList(country);
        }
        selectedValues.value.splice(selectedValues.value.indexOf(subcontinent), 1);
        subcontinentsToRemove.push(...lookup.findAllSubcontinentsInContinent(continent));
    }
    return subcontinentsToRemove;
};

const removeCountries = (subcontinent: string) => {
    const countries = lookup.findAllCountriesInSubcontinent(subcontinent);
    for (const country of countries) {
        removeValueFromList(country);
    }
};

const removeCountry = (countryName: string) => {
    removeValueFromList(countryName);
        // Remove subcontinent if no countries are selected
        const subcontinent = lookup.findSubcontinent(countryName);
        const countries = lookup.findAllCountriesInSubcontinent(subcontinent);
        const selectedCountries = countries.filter(country => selectedValues.value.includes(country));
        if (selectedCountries.length == 0) {
            removeValueFromList(subcontinent);

            // Remove continent if no subcontinents are selected
            const continent = lookup.findContinent(subcontinent);
            const subcontinents = lookup.findAllSubcontinentsInContinent(continent);
            const selectedSubcontinents = subcontinents.filter(subcontinent => selectedValues.value.includes(subcontinent));
            if (selectedSubcontinents.length == 0) {
                removeValueFromList(continent);
            }
       }
};


const removeItem = (item: string, level: string) => {
    if (level == 'Continents') {
        removeSubcontinentsAndCountries(item);
    } else if (level == 'Subcontinents') {
        removeCountries(item);
    } else if (level == 'Countries') {
        removeCountry(item);
    }
};

const removeValueFromList = (item: string) => {
  selectedValues.value = selectedValues.value.filter(value => value !== item);
};

const removeFromSelectedItems = (item: string) => {

    const level = getGroupLevel(item);

    if (level == '') {
        return;
    }
    removeItem(item, level);
};

const addSubcontinentsAndCountries = (continent: string) => {
    const subcontinents = lookup.findAllSubcontinentsInContinent(continent);
    for (const subcontinent of subcontinents) {
        const countries = lookup.findAllCountriesInSubcontinent(subcontinent);
        for (const country of countries) {
            if (!selectedValues.value.includes(country)) {
                selectedValues.value.push(country);
            }
        }
        if (!selectedValues.value.includes(subcontinent)) {
            selectedValues.value.push(subcontinent);
        }
    }
};


const addCountries = (subcontinent: string) => {
    const countries = lookup.findAllCountriesInSubcontinent(subcontinent);
    for (const country of countries) {
        if (!selectedValues.value.includes(country)) {
            selectedValues.value.push(country);
        }
    }
};


const addToSelectedItems = (item: string) => {

    if (!isAllowedAdd(item)) {
        selectedValues.value.splice(selectedValues.value.indexOf(item), 1);
        return;
    }

    const level = getGroupLevel(item);

    if (level == '') {
        return;
    }
    if (level === 'Continents') {
        addSubcontinentsAndCountries(item);
    } else if (level === 'Subcontinents') {
        addCountries(item);
    } else if (level === 'Countries') {
        if (!selectedValues.value.includes(item)) {
            selectedValues.value.push(item);
        }
    }
};

const isAllowedAdd = (item: string) => {
    const level = getGroupLevel(item);

    if (level === '' || level === 'Continents') {
        return true;
    }

    if (level === 'Subcontinents') {
        const continent = lookup.findContinent(item);
        return selectedValues.value.includes(continent);
    }

    if (level === 'Countries') {
        const subcontinent = lookup.findSubcontinent(item);
        return selectedValues.value.includes(subcontinent);
    }

}

const selectAllChanged = () => {
    if (selectAll.value) {
        selectedValues.value = [...labels];
        emit("update:modelValue", selectedValues.value);
    }
    else {
        selectedValues.value = [];
        emit("update:modelValue", selectedValues.value);
    }
};

selectAllChanged();

</script>

<style scoped lang="scss">
@import '@/scss/multiselectcheckbox';
</style>
